#property copyright " "
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

enum SourceN
   {
   forexprostools = 1,
   yahoo          = 2
   };

//       datetime > int
const datetime    DTSTART  =  D'2000.01.01 00:00:00';

const uchar       EVENT_TYPE  =  3,       // [0000 0011]
                  NSA         =  12,      // [0000 1100]
                  REVISED     =  16,      // [0001 0000]
                  PRELIM      =  32,      // [0010 0000]
                  COUNTRYS    =  64,      // [0100 0000]
                  UPD_BIT     =  128;     // [1000 0000]

const ushort      
                  VOLATILITY  =  3,       // [0000 0000 0000 0011]
                  DURATION    =  12,      // [0000 0000 0000 1100]
                  COMPARE     =  240,     // [0000 0000 1111 0000]
                  MEASURE     =  3840,    // [0000 1111 0000 0000]

                  CAT3        =  255,     // [0000 0000 1111 1111]
                  CAT2        =  65280,   // [1111 1111 0000 0000]

                  SOURCE0     =  255,     // [0000 0000 1111 1111]
                  SOURCE1     =  65280;   // [1111 1111 0000 0000]

struct            ec_struct
   {
   uint           DT;               //                      seconds after DTSTART
   uint           Modified;         //                      seconds after DTSTART
   uint           ID;
   uint           Event_ID;
   float          Actual;
   float          Forecast;
   float          Previous;
   ushort         PACK;          /* [0000 0000 0000 0011]   Volatility_ID
                                    [0000 0000 0000 1100]   Duration_ID
                                    [0000 0000 1111 0000]   Compare_ID
                                    [0000 1111 0000 0000]   Measure_ID                             */
   ushort         Cat_ID;        /* [0000 0000 1111 1111]   Cat3
                                    [1111 1111 0000 0000]   Cat2                                   */
   ushort         Source_ID;     /* [0000 0000 1111 1111]   Source0 /website; data source/
                                    [1111 1111 0000 0000]   Source1 /primary; event source; news issuer  */                                    
   ushort         Words_ID;
   uchar          FLAGS;         /*           [0000 0011]   EventType_ID
                                              [0000 1100]   (n.)s.a /(not) seasonally adjusted/          
                                              [0001 0000]   Revised
                                              [0010 0000]   Preliminary
                                              [0100 0000]   Country's                              
                                              [1000 0000]   Update bit                              */
   uchar          Country_ID;
   uchar          Currency_ID;
   uchar          Period_ID;
   };
